﻿#ifndef __HELLOWORLD_SCENE_H__
#define __HELLOWORLD_SCENE_H__

#include "cocos2d.h"

#include "Box2D\Box2D.h"
#include "GB2ShapeCache-x.h"
#include "GLES-Render.h"


USING_NS_CC;

class HelloWorld : public cocos2d::Layer
{
public:

	static cocos2d::Scene* createScene();

	virtual bool init();

	void menuCloseCallback(cocos2d::Ref* pSender);

	// Touch, nên để cả 3 hàm, mặc dù chỉ dùng 1 hàm thôi
	bool onTouchBegan(Touch* touch, Event* event);
	void onTouchMoved(Touch* touch, Event* event);
	void onTouchEnded(Touch* touch, Event* event);

	// Hàm vẽ để Debug khung body của đối tượng, lưu ý: Hàm này chỉ đúng với Engine 3.0,3.1.x nhé, Ai dùng Engine 3.2 RC0 trở lên ( ko xét alpha,beta) thì phải sửa thành.

	// virtual void draw(Renderer *renderer, const Mat4 &transform, uint32_t flags) override;

	// Kẻo lỗi tùm lum
	virtual void draw(Renderer *renderer, const Mat4 &transform, uint32_t flags) override;

	// joint
	void revoluteJoint();
	void mouseJoint();
	void pulleyJoint();

	void update(float dt);

	CREATE_FUNC(HelloWorld);

private:
	// World và đối tượng Debug Draw
	b2World* world;
	
	GLESDebugDraw *debugDraw;

	b2Body *_groundBody;
	b2Fixture *_bottomFixture;
	b2Fixture *_ballFixture;


	b2Body* groundBody;
	b2Body* m_bodyA;
	b2Body* m_bodyB;

	b2PulleyJoint* m_pulleyJoint;
	b2MouseJoint* m_mouseJoint;
	b2RevoluteJoint* m_revoluteJoint;

	b2Fixture* m_bodyAFixtures;
};

#endif // __HELLOWORLD_SCENE_H__
